<template>
  <div>
    <!--内容-->
    <div class="layout-content-padding">
      <div class="layout-content-main">
        <Row>
          <!--查询-->
          <Col span="24" style="margin-top: 10px">
            <Form v-show="searchOpen" id="formId" :label-width="90" inline onsubmit="return false">
              <label class="label-sign"></label>
              <Form-item class="search-item" label="委托单位:">
                <Input v-model="formObj.client" name="client" placeholder="请输入委托单位" clearable @on-enter="_formSearch"/>
              </Form-item>
              <Form-item class="search-item" label="合同编号:">
                <Input v-model="formObj.salesCode" name="salesCode" placeholder="请输入合同编号" clearable @on-enter="_formSearch"/>
              </Form-item>
              <Form-item class="search-btn">
                <Button type="primary" @click="_formSearch">搜索</Button>
              </Form-item>
            </Form>
          </Col>
          <!--操作-->
          <Col span="24">

            <btn-list :msg="btn" :open="searchOpen" :show-search-btn="true" class="contHide"
                     @on-result-change="_btnClick"></btn-list>
          </Col>
          <!--表格-->
          <Col span="24">
            <PTVXETable ref="pageTable" :table-height="tableHeight" :form-id="formId" :loading="true"
                        :get-page="getPage" :icon-msg="iconMsg" @on-result-change="_tableResultChange">
              <vxe-table-column
                v-for="item in pageColumns"
                :key="item.key"
                :field="item.key"
                :title="item.title"
                :min-width="item.width?item.width:200"
                :fixed="item.fixed?item.fixed:undefined" sortable>
                <template slot-scope="scope">
                  <span v-if="item.date">{{scope.row[item.key]?$dateformat(scope.row[item.key],'yyyy-mm-dd'):''}}</span>
                  <span v-else>{{scope.row[item.key]}}</span>
                </template>
              </vxe-table-column>
            </PTVXETable>
          </Col>
        </Row>
      </div>
    </div>
    <MeterReviewHisHisOperation ref="operationModal"></MeterReviewHisHisOperation>
    <FileManage ref="FileManage"></FileManage>
    <MeterSubcontractorEdit ref="editSubcontractorModal" @on-result-change="_formSearch"></MeterSubcontractorEdit>
    <MeterContractReviewAddEdit ref="addEditModal" @on-result-change="_page"></MeterContractReviewAddEdit>
  </div>
</template>
<script>
import http from '../../../api/http'
import { meterContract, meterSubcontractor } from '../../../api'
import MeterReviewHisHisOperation from '../../../components/operation/Operation'
import MeterSubcontractorEdit from './MeterContractReviewEdit'
import MeterContractReviewAddEdit from './MeterContractReviewRecord'
export default {
  components: {
    MeterSubcontractorEdit,
    MeterReviewHisHisOperation,
    MeterContractReviewAddEdit
  },
  data() {
    return {
      currentComponent: '',
      formId: 'meterSubcontractorFormId',
      searchOpen: false,
      btn: [
        // {
        //   type: 'success',
        //   id: 'contract-review-meter-contract-review-his-add',
        //   name: '添加'
        // },
        {
          type: 'success',
          id: 'meter-contract-review-his-export',
          name: '导出项目统计表'
        },
        {
          type: 'success',
          id: '',
          name: '导出合同评审记录'
        }
      ],
      iconMsg: [
        // {
        //   type: 'md-create',
        //   id: '',
        //   name: '编辑'
        // },
        // {
        //   type: 'ios-clock',
        //   id: '',
        //   name: '资质项目'
        // },
        {
          type: 'md-cloud',
          id: 'meter-contract-review-his-accessory-operation',
          name: '附件'
        },
        {
          type: 'md-create',
          id: '',
          name: '评审记录'
        },
        {
          type: 'ios-clock',
          id: 'meter-contract-review-his-record-operation',
          name: '操作日志'
        }
      ],
      formObj: {
        client: undefined,
        salesCode: undefined
      },
      selectIds: [],
      getPage: {},
      pageColumns: [
        { title: '委托单位', key: 'client', width: 200 },
        { title: '联系人', key: 'person', width: 120 },
        { title: '联系电话', key: 'tel', width: 120 },
        { title: '传真', key: 'fax', width: 120 },
        { title: '合同编号', key: 'salesCode', width: 120 },
        { title: '详细地址', key: 'address', width: 250 },
        { title: '登记日期', key: 'edate', width: 120, date: true },
        { title: '要求完成时间', key: 'odate', width: 120, date: true },
        { title: '折扣', key: 'discount', width: 120 },
        { title: '总价', key: 'totalPrice', width: 120 },
        { title: '折扣价', key: 'discountPrice', width: 120 },
        { title: '备注', key: 'remark' }
      ]
    }
  },
  computed: {
    tableHeight: function() {
      if (this.searchOpen) {
        return this.$tableHeight('search')
      } else {
        return this.$tableHeight('noSearch')
      }
    }
  },
  mounted() {
    this._page()
  },
  methods: {
    _btnClick(msg, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (msg) {
          case '添加':
            this._editModal(false)
            break
          case '导出项目统计表':
            this._exportContractTable()
            break
          case '导出合同评审记录':
            this._exportContractReviewRecord()
            break
          case 'search':
            this.searchOpen = !this.searchOpen
            break
        }
      })
    },

    _exportContractTable() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择要导出的数据!')
        return false
      }
      const sampleIds = this.selectIds.join(',')
      const data = this.formObj
      data.idsStr = sampleIds
      this.$Modal.confirm({
        title: '提示',
        content: '确定导出数据？',
        onOk: () => {
          http.open(
            '/meter/v1/contract/export_contract_statistics_table/',
            data
          )
        }
      })
    },
    _exportContractReviewRecord() {
      if (this.selectIds.length === 0) {
        this.$Message.warning('请选择要导出的数据!')
        return false
      }
      const sampleIds = this.selectIds.join(',')
      const data = this.formObj
      data.idsStr = sampleIds
      this.$Modal.confirm({
        title: '提示',
        content: '确定导出数据？',
        onOk: () => {
          http.open('/meter/v1/contract/export_contract_review_record/', data)
        }
      })
    },

    _iconClick(res, data, componentName) {
      this.currentComponent = componentName
      this.$nextTick(function() {
        switch (res) {
          case '编辑':
            this._editModal(true, data.id)
            break
          case '资质项目':
            this._itemModal(data.id)
            break
          case '附件':
            this._upload(data.id)
            break
          case '删除':
            this._deleteByIds([data.id])
            break
          case '操作日志':
            this._record(data.id)
            break
          case '评审记录':
            this._reviewContract(data.id)
            break
        }
      })
    },
    // 编辑&添加
    _reviewContract(id) {
      this._getContractReview(id)
    },
    _getContractReview: async function(id) {
      const result = await meterContract.getReviewDTOById(id)
      if (result) {
        this.$refs.addEditModal._openEdit(result)
      }
    },
    _record(id) {
      this.$refs.operationModal._open(id)
    },
    _tableResultChange(msg, data) {
      switch (msg) {
        case 'iconClick':
          this._iconClick(data.name, data.rowData, data.componentName)
          break
        case 'selectIds':
          this.selectIds = data
          break
        case 'changeSize':
          this._page()
          break
      }
    },
    _page: async function() {
      Object.assign(this.formObj, this.$refs.pageTable._searchParams())
      console.log('this.formObj', this.formObj)
      const result = await meterContract.pageContractReviewHis(this.formObj)
      if (result) {
        this.$refs.pageTable._hideLoading()
        this.getPage = result
      }
    },
    _formSearch() {
      this.$refs.pageTable._pageChange(1)
    },
    // 删除
    _deleteByIds(ids, content) {
      this.$Modal.confirm({
        title: '提示',
        content: content || '确定删除该记录？',
        onOk: () => {
          this._delete(ids)
        }
      })
    },
    // 编辑&添加
    _editModal(edit, id) {
      if (edit) {
        // 编辑
        // this.$refs.editSubcontractorModal._open(id)
        this._getById(id)
      } else {
        // 添加
        this.$refs.editSubcontractorModal._open()
      }
    },
    // 追加项目
    _itemModal(data) {
      // this.$refs.refModal._open(data)
    },

    _upload(id) {
      // 上传文件
      // this.$refs.refModal._open(id, 'subcontractorId')
      this.$refs.FileManage._open(id, 'subcontractorId')
    },
    _getById: async function(id) {
      const result = await meterSubcontractor.getById(id)
      if (result) {
        this.$refs.editSubcontractorModal._open(result)
      }
    },
    _delete: async function(ids) {
      const result = await meterSubcontractor.deleteById(ids)
      if (result) {
        this._formSearch()
        this.$Message.success('删除成功！')
      }
    }
  }
}
</script>
